; Borderless Banner with Commodore Chicklet Logo
; September 22, 2024 by KPK

* = $801

!hex 20080a009e323038323a8f2032322d5345502d32303234204259204b504b000000

init:
  lda #1
  sta $286
  lda #147
  jsr $ffd2
  lda #14
  sta x_loc
  lda #18
  sta y_loc
  lda #0
  sta msg_ptr
  
message:
- ldx y_loc
  ldy x_loc
  jsr $fff0
  ldy msg_ptr
  lda msg,y
  beq setup_sprite
  jsr $ffd2
  inc msg_ptr
  inc x_loc
  dec y_loc
  bne -

setup_sprite:
  ldy #0
- lda chicklet_sprite,y ; copy sprite data into target location
  sta 832,y
  iny
  cpy #64
  bne -
  lda #13     ; 13*64=832
  sta $07f8   ; sprite 0 data pointer
  lda #142
  sta $d000   ; sprite 0 x pos
  lda #138
  sta $d001   ; sprite 0 y pos
  lda #15
  sta $d026   ; sprites mc reg 1
  lda #11
  sta $d027   ; sprite 0 color
  lda #1
  sta $d01c   ; sprites mc mode
  sta $d025   ; sprites mc reg 0
  sta $d015   ; sprites enable

loop1:
  lda #$5a
  sta $fb
  lda #$00
  sta $d020
  sta $d021
  ldx #$0f
  sei
loop2:
- lda $d011
  bmi -
- lda $d012
  cmp $fb
  bne -
  inc $d020
  inc $d021
  clc
  adc #$08
  sta $fb
  dex
  bpl loop2
  bmi loop1

x_loc:   !fill 1
y_loc:   !fill 1
msg_ptr: !fill 1
msg:     !pet "commodore 64!",0

chicklet_sprite:
!byte $00,$00,$00,$03,$fb,$00,$07,$7e
!byte $00,$35,$df,$00,$1d,$77,$00,$b7
!byte $5d,$00,$bd,$83,$7e,$ef,$01,$de
!byte $bb,$01,$78,$ae,$03,$70,$eb,$00
!byte $00,$ba,$03,$60,$ee,$03,$d8,$fb
!byte $02,$f6,$fe,$83,$bd,$9f,$ba,$00
!byte $37,$ee,$00,$3d,$fb,$00,$07,$7e
!byte $00,$03,$df,$00,$00,$00,$00