; ***** SPIRAL - 1/12/2011 BY KEVIN KRAUSNICK *****
; ***** SPIRALS INWARD FROM THE OUTER EDGE OF THE SCREEN *****

.INCLUDE SYSTEM.ASM

* = $801		; Start of BASIC (2049 decimal)

; CREDITS - "10 SYS2082:REM BY KEVIN KRAUSNICK"
.BYTE 32,8,10,0,158,50,48,56,50,58,143,32,66,89,32,75
.BYTE 69,86,73,78,32,75,82,65,85,83,78,73,67,75,0,0,0

;--------------------------------------------------------------------------------

; *** Initialization ***

L0	LDY #0
	STY BORDER	; Set border color (black)
	STY BACKGND	; Set background color (black)
	STY CURSX
	STY CURSY	; Starting cursor location
J1	LDA JIFFY	; Select a random foreground color, different from background
	AND #$0F
	BEQ J1
	STA FOREGND
	LDA #39
	STA WIDTH	; Initial line width
	LDA #23
	STA HEIGHT	; Initial line height
	JSR CLRSCR	; Clear screen

;--------------------------------------------------------------------------------

; *** Main program loop ***

L1	LDA #LINEX	; Top line
	LDY WIDTH
L2	JSR DRAWCHAR
	INC CURSX
	DEY
	BNE L2
	LDA #UPPERR
	JSR DRAWCHAR
	INC CURSY
	DEC WIDTH

	LDA #LINEY	; Right line
	LDY HEIGHT
        BEQ KYBDLOOP
L3	JSR DRAWCHAR
	INC CURSY
	DEY
	BNE L3
	LDA #LOWERR
	JSR DRAWCHAR
	DEC CURSX
	DEC HEIGHT

	LDA #LINEX	; Bottom line
	LDY WIDTH
L4	JSR DRAWCHAR
	DEC CURSX
	DEY
	BNE L4
	LDA #LOWERL
	JSR DRAWCHAR
	DEC CURSY
	DEC WIDTH

	LDA #LINEY	; Left line
	LDY HEIGHT
	BEQ L5A
L5	JSR DRAWCHAR
	DEC CURSY
	DEY
	BNE L5
	DEC HEIGHT
L5A	LDA #UPPERL
	JSR DRAWCHAR
	INC CURSX
	JMP L1		; Prepare to draw next concentric ring

;--------------------------------------------------------------------------------

; *** Prepare to exit program ***

KYBDLOOP JSR GETIN	; Wait for keypress
	BEQ KYBDLOOP
	CMP #RETURN
	BEQ K1
	CMP #SPACE
	BEQ K1
	JSR CLRSCR	; Clear screen
	RTS		; Exit program
K1	JMP L0

;--------------------------------------------------------------------------------

; *** Draw character ***

DRAWCHAR STA CHAR
	PHA
	TYA
	PHA

	LDY CURSX
	LDX CURSY
	CLC
	JSR PLOT	; Set cursor position

	LDA CHAR
	LDX FOREGND
	JSR SETCHAR	; Set character & color at cursor position

	LDY #0		; Wait long enough for animation to be visible
DELAY	DEY
	BNE DELAY

	PLA
	TAY
	PLA
	RTS

;--------------------------------------------------------------------------------

; *** Constants ***

BORDER	=	53280	; Border color
BACKGND	=	53281	; Background color
CLRSCR	=	$E544	; Clear Screen Kernel routine
SETCHAR	=	$EA1C	; Set character & color at cursor position Kernel routine
JIFFY	=	$A2	; Jiffy Clock used as a random number generator
UPPERL	=	85	; CBM code for character at upper-left corner
UPPERR	=	73	; CBM code for character at upper-right corner
LOWERL	=	74	; CBM code for character at lower-left corner
LOWERR	=	75	; CBM code for character at lower-right corner
LINEX	=	67	; CBM code for horizontal line character
LINEY	=	93	; CBM code for vertical line character
RETURN	=	13	; CBM code for carriage return
SPACE	=	32	; CBM code for space bar

;--------------------------------------------------------------------------------

; *** Program variables ***

WIDTH	.BYTE	0	; Initial line width
HEIGHT	.BYTE 	0	; Initial line height
CURSX	.BYTE 	0	; Initial cursor location (x)
CURSY	.BYTE 	0	; Initial cursor location (y)
CHAR	.BYTE	0	; Character to draw
FOREGND	.BYTE	0	; Foreground color
