; ***** SURROUND - 1/11/2011 BY KEVIN KRAUSNICK *****
; ***** DRAWS SPIRAL RINGS IN INCREMENTAL COLORS *****

.INCLUDE SYSTEM.ASM

* = $801		; Start of BASIC (2049 decimal)

; CREDITS - "10 SYS2082:REM BY KEVIN KRAUSNICK"
.BYTE 32,8,10,0,158,50,48,56,50,58,143,32,66,89,32,75
.BYTE 69,86,73,78,32,75,82,65,85,83,78,73,67,75,0,0,0

;--------------------------------------------------------------------------------

; *** Initialization ***

    LDY #0
    STY BORDER		; Set border color (black)
    STY BACKGND		; Set background color (black)
    STY CURSX
    STY CURSY		; Starting cursor location
    INY
    STY FORE		; Initial foreground color (white)
    LDA #38
    STA WIDTH		; Initial line width
    LDA #23
    STA HEIGHT		; Initial line height
    JSR CLRSCR		; Clear screen

;--------------------------------------------------------------------------------

; *** Main program loop ***

L1  LDA #85		; Top line
    JSR DRAWCHAR
    INC CURSX
    LDA #67
    LDY WIDTH
L2  JSR DRAWCHAR
    INC CURSX
    DEY
    BNE L2

    LDA #73		; Right line
    JSR DRAWCHAR
    INC CURSY
    LDA #93
    LDY HEIGHT
L3  JSR DRAWCHAR
    INC CURSY
    DEY
    BNE L3

    LDA #75		; Bottom line
    JSR DRAWCHAR
    DEC CURSX
    LDA #67
    LDY WIDTH
L4  JSR DRAWCHAR
    DEC CURSX
    DEY
    BNE L4

    LDA #74		; Left line
    JSR DRAWCHAR
    DEC CURSY
    LDA #93
    LDY HEIGHT
L5  JSR DRAWCHAR
    DEC CURSY
    DEY
    BNE L5
    JSR DELAY

    INC FORE		; Prepare to draw next concentric ring
    INC CURSY
    INC CURSX
    DEC WIDTH
    DEC WIDTH
    DEC HEIGHT
    DEC HEIGHT
    LDA CURSY
    CMP #12
    BNE L1

    LDA #67
    LDY WIDTH
    INY
    INY
L6  JSR DRAWCHAR
    INC CURSX
    DEY
    BNE L6

;--------------------------------------------------------------------------------

; *** Prepare to exit program ***

KYBDLOOP = *		; Wait for keypress
    JSR GETIN
    BEQ KYBDLOOP
    JSR CLRSCR		; Clear screen
    RTS			; Exit program

;--------------------------------------------------------------------------------

; *** Draw character ***

DRAWCHAR = *
    STA CHAR
    PHA
    TYA
    PHA

    LDY CURSX
    LDX CURSY
    CLC
    JSR PLOT		; Set cursor position

    LDA CHAR
    LDX FORE
    JSR SETCHAR		; Set character & color at cursor position

    PLA
    TAY
    PLA
    RTS

;--------------------------------------------------------------------------------

; *** Delay program execution ***

DELAY = *		; wait long enough for animation to be visible
    LDX #80
    LDY #0
D1  DEY
    BNE D1
    DEX
    BNE D1
    RTS

;--------------------------------------------------------------------------------

; *** Constants ***

BORDER	=	53280	; Border color
BACKGND	=	53281	; Background color
CLRSCR	=	$E544	; Clear Screen
SETCHAR	=	$EA1C	; Set character & color at cursor position

;--------------------------------------------------------------------------------

; *** Program variables ***

WIDTH	.BYTE	38	; Initial line width
HEIGHT	.BYTE 	23	; Initial line height
CURSX	.BYTE 	0	; Initial cursor location (x)
CURSY	.BYTE 	0	; Initial cursor location (y)
FORE	.BYTE	1	; Foreground color value (different for each ring)
CHAR	.BYTE	0	; Character to draw
