; ***** ZIG ZAG - 12/28/2010 BY KEVIN KRAUSNICK *****
; ***** DRAWS STARS DOWN THE SCREEN IN A ZIG ZAG PATTERN *****

.INCLUDE SYSTEM.ASM

* = 2049		; $801 = START OF BASIC

; CREDITS - "10 SYS2082:REM BY KEVIN KRAUSNICK"
.BYTE 32,8,10,0,158,50,48,56,50,58,143,32,66,89,32,75
.BYTE 69,86,73,78,32,75,82,65,85,83,78,73,67,75,0,0,0

;--------------------------------------------------------------------------------

; *** INITIALIZATION ***

    LDA #BLACK
    STA BORDER		; SET BORDER COLOR
    STA BACK		; SET BACKGROUND COLOR
    LDA #WHITE
    STA FORE		; SET INITIAL FOREGROUND COLOR
    LDA #0
    STA LINENO		; SET INITIAL LINE #

    LDA #CLS
    JSR CHROUT		; CLEAR SCREEN

    LDA #<SCREENRAM	; SAVE POINTER TO SCREEN RAM
    STA $F9
    LDA #>SCREENRAM
    STA $FA

    LDA #<COLORRAM	; SAVE POINTER TO COLOR RAM
    STA $FB
    LDA #>COLORRAM
    STA $FC

;--------------------------------------------------------------------------------

; *** MAIN PROGRAM LOOP ***

MAINLOOP = *

    LDY #0		; *** TOP LINE ***
L1  JSR DRAWSTAR
    INY
    CPY #40
    BNE L1

    JSR OFFSETUP
    LDA LINENO
    CMP #25
    BEQ KYBDLOOP

    DEY
L2  JSR DRAWSTAR
    DEY
    BNE L2
    JSR DRAWSTAR

    JSR OFFSETUP
    JMP MAINLOOP

;--------------------------------------------------------------------------------

; *** CLEAN-UP AND PREPARE TO EXIT PROGRAM ***

KYBDLOOP = *		; WAIT FOR KEYPRESS
    JSR GETIN
    BEQ KYBDLOOP
    LDA #CLS		; CLEAR SCREEN
    JSR CHROUT
    RTS			; EXIT PROGRAM

;--------------------------------------------------------------------------------

; *** DRAW STAR ***

DRAWSTAR = *
    LDA #ASTERISK
    STA ($F9),Y
    LDA FORE
    STA ($FB),Y

    TYA			; SAVE REGISTERS
    PHA
    TXA
    PHA

; *** TIME DELAY ***

    LDX #4		; WAIT LONG ENOUGH FOR ANIMATION TO BE VISIBLE
L4  LDY #0
L5  NOP
    DEY
    BNE L5
    DEX
    BNE L4

    PLA			; RESTORE REGISTERS
    TAX
    PLA
    TAY
    RTS

;--------------------------------------------------------------------------------

; *** INCREASE OFFSET ***

OFFSETUP = *
    CLC
    LDA $F9
    ADC #40
    STA $F9
    LDA $FA
    ADC #0
    STA $FA

    CLC
    LDA $FB
    ADC #40
    STA $FB
    LDA $FC
    ADC #0
    STA $FC

    INC LINENO
    INC FORE
    LDA FORE
    CMP #16
    BNE L3
    LDA #1
    STA FORE
L3  RTS

;--------------------------------------------------------------------------------

; *** CONSTANTS ***

CLS	= 147		; CBM code to clear screen
ASTERISK = 42		; CBM code for asterisk character
BLACK	= 0		; Color black
WHITE	= 1		; Color white
BORDER	= 53280		; Border color
BACK	= 53281		; Background color

;--------------------------------------------------------------------------------

; *** PROGRAM VARIABLES AND STRINGS ***

FORE	.BYTE 1		; Foreground color value (each line is a different color)
LINENO	.BYTE 0		; Line number
